/*
 * wnix, a Unix-like operating system for WebAssembly applications.
 * Copyright (C) 2025  Xavier Del Campo Romero
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <bin.h>
#include <bin/mod.h>
#include <bin/types.h>
#include <stddef.h>

int bin_mod_move(struct bin_mod *const m, struct bin *const from,
    struct bin *const to)
{
    if (from)
    {
        if (from->mod_head == m)
            from->mod_head = m->next;

        if (from->mod_tail == m)
            from->mod_tail = m->prev;
    }

    if (m->next)
        m->next->prev = m->prev;

    if (m->prev)
        m->prev->next = m->next;

    if (to)
    {
        if (!to->mod_head)
        {
            to->mod_head = m;
            m->prev = m->next = NULL;
        }
        else
        {
            struct bin_mod *const t = to->mod_tail;

            t->next = m;
            m->prev = t;
            m->next = NULL;
        }

        to->mod_tail = m;
    }

    return 0;
}
